/* this file is decrunch.c, 5/29/91, to decompress an image file */
#include <stdio.h>
#include <math.h>
typedef unsigned char byte;
int	ana_type_size[5]={1,2,4,4,8};
	FILE *fopen(),*fin,*fout;
	void perror(),exit(),badnews(int i);
	int	n,nw,i,nq,iq,sbit,ic;
	short	xmax,xmin;
	short	xq[300000],xqq[300000];
	float	fq;
	struct fzhead {
		int	synch_pattern;
		byte	subf;
		byte	sour;
		byte	nhb,datyp,ndim,free1;
		byte	cbytes[4];	/* can't do as int because of %4 rule*/
		byte	free[178];
		int	dim[16];
		char	txt[256];} fh,fh2;

	struct compresshead {
		int	tsize,nblocks,bsize;
		byte	slice_size,type; } ch;

	union {	int i;	byte b[4];} lmap;
/*----------------------------------------------------------------------------*/
main(argc,argv)

int argc;	char *argv[];

{
if (argc<2) printf("expand requires an input and output file\n");
	
if ((fin=fopen(argv[1],"r")) == NULL)
			{(void)printf("%s: cannot open %s \n",argv[0],argv[1]);
			perror("");
			exit(3);	}
if ((fout=fopen(argv[2],"w")) == NULL)
			{(void)printf("%s: cannot open %s \n",argv[0],argv[2]);
			perror("");
			exit(3);	}
			/* read the input file and decompress if necessary */
if (fread(&fh,1,512,fin) != 512) badnews(1);
						/*check if a fz file */
if (fh.synch_pattern != 0x5555aaaa) {
 printf("file does not have the F0 synch pattern, instead it has %x\n"
 ,fh.synch_pattern);
 exit(2);}
						/* compressed ? */
ic=fh.subf%128;
						/*start writing output with
						compression flag off */
fh.subf=0;  if (fwrite(&fh,1,512,fout) != 512) badnews(2);
						/*reorder bytes in dimensions*/
/* (void) swapl(&fh.dim[0],(int) fh.ndim); */
						/* compute size of array */
n=ana_type_size[fh.datyp];
for (i=0;i<fh.ndim;i++) { n*=fh.dim[i];}
			/* if the header is long, read in the rest now
			and write it out */
if (fh.nhb >1 ) {nq=512*(fh.nhb-1);
	if (fread(xqq,1,nq,fin) != nq) badnews(3);
	if (fwrite(xqq,1,nq,fout) != nq) badnews(4); }
/* big branch on compression flag */
if (ic == 1 )	{			/* compression case */
					/* read in the compression header */ 
if (fread(&ch,1,14,fin) != 14) badnews(5);
/* swapl(&ch.tsize,1);	swapl(&ch.nblocks,1);	swapl(&ch.bsize,1); */
for (i=0;i<4;i++) lmap.b[i]=fh.cbytes[i];
/* swapl(&lmap.i,1); */
					/* read in the compressed data */
nq=ch.tsize-14; if (fread(xqq,1,nq,fin) != nq) badnews(6);
sbit=ch.slice_size;			/* fixed slice size */
/* printf("nq, sbit = %d %d \n", nq, sbit); */
if (fh.datyp == 1) {
(void) anadecrunch(xqq,xq,sbit,ch.bsize,ch.nblocks); /* result in xq array */
/* (void) swab(xq,xqq,n); */			/*swab and put back in xqq */
}
else if (fh.datyp == 0) {
(void) anadecrunch8(xqq,xq,sbit,ch.bsize,ch.nblocks);
}
} else {					/* non-compression case */
						/* really just a copy   */
if (fread(xqq,1,n,fin) != n) badnews(7);
	}

						/* common section again */
/* if (fh.datyp == 0 && ic == 1) { */
if ( ic == 1) {
if (fwrite(xq,1,n,fout) != n) badnews(8); } else {
if (fwrite(xqq,1,n,fout) != n) badnews(9);}
(void) exit(1);
}
/*----------------------------------------------------------------------------*/
void badnews(i)				/* badnews for file reads/writes
					always exits */
int i;
{
 switch (i) {
case 1: printf("EXPAND: error while reading header\n"); break;
case 2: printf("EXPAND: error while writing header\n"); break;
case 3: printf("EXPAND: error while reading extra header blocks\n"); break;
case 4: printf("EXPAND: error while writing extra header blocks\n"); break;
case 5: printf("EXPAND: error while reading compression header\n"); break;
case 6: printf("EXPAND: error while reading compressed data\n"); break;
case 7: printf("EXPAND: error while reading uncompressed data\n"); break;
case 8: printf("EXPAND: error while writing out (from compressed)\n"); break;
case 9: printf("EXPAND: error while writing out (from uncompressed)\n"); break;
}
perror("");
exit(2);
}
