pro msok_copy_jpg, date
;
;+
;   Name: msok_copy_jpg
;
;   Purpose: copy daily Meese Ca Kline jpeg file
;
;   6-nov-1995 (SLF)
;-

;------- ftp param ---------
ftpnode='akala.ifa.hawaii.edu'
subdir ='/pub/kline'
;----------------------------

; get directory
ftp_copy,xx,ftpnode,subdir,/list,dirlist=dirlist,/anon

cols=str2cols(dirlist)

files=strtrim(cols(8,*),2)

ss=wc_where(files,'K*.jpg',sscnt)

if sscnt gt 0 then begin
   outdir=get_logenv('DIR_GEN_MCK')   
   chk=concat_dir(outdir,files(ss))
   none=where(1-file_exist(chk),sscnt)
   if sscnt gt 0 then begin
      message,/info,"Need to get " + strtrim(sscnt,2) + " files..."
      ftp_copy, files(ss(none)), ftpnode, subdir,/anon, outdir=outdir,/get

   endif else message,/info,"Already have all MCK jpeg files.."
endif else message,/info,"No KLINE files found...

return
end

