pro mk_gxt, week=week, outdir=outdir, run_time=run_time
;
;+
;NAME:
;	mk_gxt
;PURPOSE:
;	write binary file containing digitized daily GOES
;	soft xray plots (derived from Tektronics plot files)
;KEYWORD INPUT:
;       week    - a string with the year/week if the format
;                 91_49 where 91 is the year, 49 is the week
;                 This is required input.
;OPTIONAL KEYWORD INPUT:
;	outdir	- The output directory for the output file.
;		  If undefined, write it to $DIR_GEN_GXT.
;HISTORY:
;	S.L.Freeland, 11-Sep-92 
;	(Using mk_gev by M.Morrison as template)
;	10-Oct-1992 - changed file name generation to avoid sort
;	15-Apr-93 (MDM) - Replace with a call to MK_GX
;	29-Apr-93 (MDM) - Replaced with a call to MK_WEEK_FILE
;-
;
mk_week_file, 'GXT', week=week, outdir=outdir, run_time=run_time
;
end
